/*****************************************************
This program was produced by the
omercury

Chip type               : ATiny13
Program type            : Application
AVR Core Clock frequency: 9,600000 MHz
*****************************************************/

#include <tiny13.h>
//#include <delay.h>          //  

#define secundes 900    // 60  * 15 
#define timDiv   600    // ~600     

#define shortkey  0x80    //80 .  -    
#define longkey   0xFE    //240.  -    
#define PWM_del   0x0A    //15.     
#define PWM_start 0xF0    //125. .   

unsigned int    timCount = 0;    //   
unsigned int    systemClock = 0; //   
unsigned char   tmpPWM = PWM_start; 
unsigned char   count = 0;      //   
unsigned char   b_count = 0;    //   
bit     KeyEXE;                     //  
bit     KeyNew;                     //  
bit     PWM_on;                     //   
bit     Dir_on;                     //   PWM

#define SBIT(ADDRESS,BIT) ((ADDRESS) |= (1<<(BIT)))
#define CBIT(ADDRESS,BIT)  ((ADDRESS) &= ~(1<<(BIT)))
#define KeyPress    (!PINB.1)       // 
#define led_on      (PORTB.0)

//  (.  )
void    bright_ch(void)
{
    b_count++;				    //  
    if  (b_count>=PWM_del)	    // 
    {                   
        if  (Dir_on)            //     +
        {   
            OCR0A++;             // 
            if  (OCR0A==0){OCR0A=0xFF;}  //  
        }
        else                    //     -
        {
            OCR0A--;  			//            
            if (OCR0A==0xFF){ OCR0A=0;}  //  
        } 
        b_count = 0x00;		//    
    }
}
// 
void    clr_var(void)
{
    count = 0;          //    
    b_count = 0;        //     PWM   
    KeyNew = 0;       //       
    
}
/// 
void    led_on_off(void)
{
    if  (PWM_on)                //   ()
    {    
        tmpPWM = OCR0A;  
        OCR0A=0xFF;              // 
        PWM_on = 0;             // 
    }
    else                        //   - 
    {     
        OCR0A=tmpPWM;//PWM_start;         //
        PWM_on = 1;             //    
    }                                               
}

// 
void    key_scan(void)
{
    if  KeyPress                //  
    {                            //,    
        if (KeyNew)             //   ( "")
        {                                          
            count++;          //  
            if  (count>longkey) //  
            {                                
                bright_ch();    //   
                count--;        // (-   )
                PWM_on = 1;
            }                   //
        } 
        else                    //  ,    
        {   
            KeyNew = 1;         // 
        }                       //  
        systemClock = 0;        //   
    }   
    else                        //      ,  
    {       //        ,     
        if (KeyNew)             //   (  )
        {                       //,    
            if (count<longkey)  //  ( )
            {//   ,      ,       
                if (count>shortkey) //   (,   )
                {                     
                    led_on_off();   /// 
                }               // -   
            }   
            else    {Dir_on=~Dir_on;}   //   
        }                       
        clr_var();              // 
    }                           //  
    KeyEXE = 0;                 //     
    #asm("sleep")               // 
}

// Time 0 overflow interrupt service routine
//   8 mS
interrupt [TIM0_OVF] void Time0_ovf_isr(void)
{ 
    KeyEXE = 1;          //   
    timCount++;
    if (timCount > timDiv) 
    {
        timCount=0; systemClock++;
    }
}
// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
    GIMSK=0x00;  //Disable External Interrupt-0    
    MCUCR=0x20; //Idle Mode interrupt by level
    TCCR0A=0xC3; //Fast PWM (Mode 3) Set OC0B on Compare Match, clear OC0B at TOP
    TCCR0B=0x03; //CLK/64 Enable Timer  
    clr_var();   //  
    PWM_on = 0;
    led_on_off();
}

void I_Want_Sleep(void)
{
	systemClock = 0;   
	PWM_on = 1;
	led_on_off();       
    TCCR0B=0;   //Disable timer
    MCUCR=0x30; //PowerDown Mode interrupt by level 
    GIMSK=0x40; //Enable External Interrupt-0
    #asm("sleep")           //   
}

void main(void)
{
// Input/Output Ports initialization
PORTB=0x00;
DDRB=(1<<led_on);
// Time/Counter 0 initialization
// Clock source: System Clock/64
// Clock value: 585.9 Hz
TCCR0A=0xC3;//Fast PWM (Mode 3) Set OC0B on Compare Match, clear OC0B at TOP
TCCR0B=0x03;//CLK/64
TCNT0=0x00;
OCR0A=PWM_start;
OCR0B=0xFF; //  )))
tmpPWM=PWM_start;

// Time(s)/Counter(s) Interrupt(s) initialization
TIMSK0=0x02;//Timer Overflow Interrupt

// Global enable interrupts
#asm("sei")

I_Want_Sleep(); //   PowerDown

while (1)
      {
            if  (KeyEXE)
            {  
                key_scan();
            }  
            if  (systemClock > secundes)
            {
                I_Want_Sleep(); //   PowerDown
            }
      }
}
